<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use App\Enums\BudgetStatusType;
use App\Enums\BudgetType;

return new class extends Migration {
  /**
   * Run the migrations.
   */
  public function up(): void
  {
    Schema::create('budgets', function (Blueprint $table) {
      $table->id();
      $table->foreignId('company_id')->constrained('companies');
      $table->foreignId('user_id')->constrained('users');
      $table->foreignId('user_review_id')->nullable()->constrained('users');
      $table->foreignId('balance_id')->nullable()->constrained('balances');
      $table->foreignId('department_id')->nullable()->constrained('departments');
      $table->string('name');
      $table->string('code')->index();
      $table->string('type')->default(BudgetType::CashAdvance)->index();
      $table->date('date');
      $table->year('year');
      $table->bigInteger('debit_amount');
      $table->bigInteger('credit_amount');
      $table->text('description')->nullable();
      $table->string('status')->default(BudgetStatusType::Draft)->index();
      $table->text('status_message')->nullable();
      $table->timestamp('review_at')->nullable();
      $table->timestamps();
    });
  }

  /**
   * Reverse the migrations.
   */
  public function down(): void
  {
    Schema::dropIfExists('budgets');
  }
};
